//------------------------------------------------------------------------------
// aviutlvOC C^Ȓጸ(LPF)
// Copyright (c) 2005-2008  N099
//------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>

#include "filter.h"
#include "mov.h"
#include "blend.h"
#include "mt_proc.h"

//---------------------------------------------------------------------
// \̂Ȃ
//---------------------------------------------------------------------
//臒l̔{
#define TH_MAG  8
#define TH_MAG2 2

//SIMD Flags
#define SIMD_MMX  1
#define SIMD_SSE  2
#define SIMD_SSE2 4

//---------------------------------------------------------------------
// ֐Ȃ
//---------------------------------------------------------------------
BOOL mt_exec_dummy(MULTI_THREAD_FUNC fn, void *p1, void *p2);
int is_simd_available(void);
int is_aligned_16b(const void *p0, const void *p1, int s);
BOOL alloc_work(mov_cache *mc, int h, int w);
void set_mt_proc(int mask);

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 5
TCHAR *track_name[] = {"tap", "", "", "", "2", "SIMD", "T" };
int   track_default[] = { 0, 0, 0, 24, 64, 3, 0 };
int   track_s[] = { 0, 0 , 0, 0, 0, 0, 0 };
int   track_e[] = { 6, 256, 256, 256, 256, 3, 4 };
enum  { T_TAP, T_TOP, T_BTM, T_MTH, T_NTH, T_SIMD, T_TM };

#define CHECK_N 3
TCHAR *check_name[]
 = { "̕\", "t[QƂ", "MAX" };
int    check_default[] = { 0, 0, 0 };
enum { C_DISP, C_BOTH, C_MAX };

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_NO_INIT_DATA, 0,0,
    "C^Ȓጸ{{",
    TRACK_N, track_name, track_default, track_s, track_e,
    CHECK_N, check_name, check_default,
    func_proc,
    func_init,
    func_exit,
    func_update,
    NULL,
    NULL,NULL,
    NULL,
    0,
    "lpf_decomb by N099, ver1.4.2",
    NULL, NULL,
};

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
SET_RTH f_setth = set_rth;
MULTI_THREAD_FUNC mp_lpf[2] = { mt_proc_lpf, mt_proc_lpf };
MULTI_THREAD_FUNC mp_abs[2] = { mt_proc_abs, mt_proc_abs };
MULTI_THREAD_FUNC mp_mov = mt_proc_mov;
MULTI_THREAD_FUNC mp_blend = mt_proc_blend;

//LbV
mov_cache gmc;

//uhp
__m128 grth = { 0.0f, 0.0f, 0.0f, 0.0f };

//fobOp
#if TRACK_N >= 7
LARGE_INTEGER g_ct[10];
#define QP_COUNT(a)  QueryPerformanceCounter(&g_ct[a])
#else
#define QP_COUNT(a)
#endif

//JE^
volatile LONG gpad[32];
volatile LONG gcnt[32];

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable(void)
{
    return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
    ZeroMemory(&gmc, sizeof(gmc));
    
    //֐̐ݒ
    set_mt_proc(SIMD_MMX|SIMD_SSE|SIMD_SSE2);
    
    return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
    //Ɨ̈̊J
    if(gmc.buf != NULL){
        VirtualFree(gmc.buf, 0, MEM_RELEASE);
        ZeroMemory(&gmc, sizeof(gmc));
    }
    
    return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
    switch(status){
      case FILTER_UPDATE_STATUS_TRACK + T_TOP:
      case FILTER_UPDATE_STATUS_TRACK + T_BTM:
      case FILTER_UPDATE_STATUS_TRACK + T_MTH:
      case FILTER_UPDATE_STATUS_TRACK + T_NTH:
      case FILTER_UPDATE_STATUS_ALL:
        //LbṼNA
        gmc.mv[0].frame = gmc.mv[1].frame = -1;
        break;
      default:
        break;
    }
    
    return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
    int align;
    PIXEL_YC *ycp;
    mt_param m_para;
    BOOL (*exec_mt)(MULTI_THREAD_FUNC, void*, void*) = NULL;
    
    //}`Xbh֐płꍇg
    exec_mt = fp->exfunc->exec_multi_thread_func;
    if(exec_mt == NULL) exec_mt = mt_exec_dummy;

    //LbV̐ݒ
    if(!fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->max_w, fpip->max_h, 2, 0)){
        return FALSE;
    }

    QP_COUNT(0);

    //t[̎擾
    ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp, fpip->frame,
                                                 &fpip->w, &fpip->h);
    if(ycp == NULL){
        return FALSE;
    }

    //p[^Zbg
    m_para.edit = ycp;
    m_para.temp = fpip->ycp_temp;
    m_para.fn  = fp->track[T_TAP];
    m_para.th  = fp->track[T_NTH] * TH_MAG2;
    m_para.h   = fpip->h;
    m_para.w   = fpip->w;
    m_para.s   = fpip->max_w;
    m_para.top = (fp->track[T_TOP] >= fpip->h) ? fpip->h : fp->track[T_TOP];
    m_para.btm = (m_para.top > (fpip->h - fp->track[T_BTM]))
        ? m_para.top : (fpip->h - fp->track[T_BTM]);

#if TRACK_N >= 6 //debug
    set_mt_proc((1 << fp->track[T_SIMD]) - 1);
#endif
    
    //LPF
    align = is_aligned_16b(ycp, fpip->ycp_temp, fpip->max_w);
    exec_mt(mp_lpf[align], &m_para, NULL);
    _mm_empty();
    
    QP_COUNT(2);
    
    //Ksǂŕ
    if(fp->track[T_MTH] > 0){ ///o
        mov_dtc *pmd[2];
        int frame;
        
        //臒lZbg
        f_setth((float*)&grth, fp->track[T_MTH] * TH_MAG);
        
        //Ɨ̈̊m
        if(!alloc_work(&gmc, fpip->max_h, fpip->max_w))
          return FALSE;
        
        //t[Rs[iʂǁj
        gcnt[0] = 0;
        m_para.edit = fpip->ycp_edit;
        exec_mt(mt_proc_copy, &m_para, ycp);
        
        //oʃLbV
        // mv[0] ɂ͋t[
        // mv[1] ɂ͊t[
        // r̊ƂOt[Ƃ̌oʂLbVĂ
        // ̂ŁAÕt[̈͂قƂǂ̏ꍇLbVqbg
        
        //̃t[Ƃ̍
        frame = fpip->frame + 1;
        pmd[1] = &gmc.mv[frame & 1];
        if(pmd[1]->frame != frame){
            //LbVĂȂ̂Ōos
            ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp,
                                                         frame, NULL, NULL);
            if(ycp){
                gcnt[0] = gcnt[1] = 0;
                m_para.temp = ycp;
                align = is_aligned_16b(fpip->ycp_edit, ycp, fpip->max_w);
                QP_COUNT(3);
                exec_mt(mp_abs[align], &m_para, NULL);
                QP_COUNT(4);
                exec_mt(mp_mov, &m_para, pmd[1]);
                QP_COUNT(5);
            }
            pmd[1]->frame = frame;
        }
        
        //1t[OƂ̍
        frame = fpip->frame;
        pmd[0] = &gmc.mv[frame & 1];
        if(pmd[0]->frame != frame){
            //LbVĂȂ̂Ōos
            ycp = fp->exfunc->get_ycp_filtering_cache_ex(fp, fpip->editp,
                                                         frame-1, NULL, NULL);
            if(ycp){
                gcnt[0] = gcnt[1] = 0;
                m_para.temp = ycp;
                align = is_aligned_16b(fpip->ycp_edit, ycp, fpip->max_w);
                exec_mt(mp_abs[align], &m_para, NULL);
                exec_mt(mp_mov, &m_para, pmd[0]);
            }
            pmd[0]->frame = frame;
        }
            
        //uh
        m_para.fn = fp->check[C_BOTH] * (fp->check[C_MAX] + 1);
        m_para.temp = fpip->ycp_temp;
        gcnt[0] = 0;
        QP_COUNT(6);
        exec_mt(mp_blend, &m_para, pmd);
        QP_COUNT(7);
        
        //̕\
        if(fp->check[C_DISP]){
            disp_motion(fpip->ycp_temp + m_para.top * m_para.s,
                        pmd[0]->mask, pmd[1]->mask, m_para.fn,
                        m_para.btm - m_para.top,
                        fpip->w, fpip->max_w);
        }
    }else{ ///oȂ
        //svȍƗ̈J
        if(gmc.buf != NULL){
            VirtualFree(gmc.buf, 0, MEM_RELEASE);
            gmc.buf = NULL;
        }
        gmc.mv[0].frame = gmc.mv[1].frame = -1;
    }

    //ʂycp_tempɓĂ̂œւ
    ycp = fpip->ycp_temp;
    fpip->ycp_temp = fpip->ycp_edit;
    fpip->ycp_edit = ycp;
    
    _mm_empty();
    
    QP_COUNT(1);
    
#if TRACK_N >= 7
    if(!fp->exfunc->is_saving(fpip->editp)){
        TCHAR buf[256];
        double d;
        if(fp->track[T_TM] == 1){
            d = (double)(g_ct[2].QuadPart - g_ct[0].QuadPart);
        }else if(fp->track[T_TM] == 2){
            d = (double)(g_ct[4].QuadPart - g_ct[3].QuadPart);
        }else if(fp->track[T_TM] == 3){
            d = (double)(g_ct[5].QuadPart - g_ct[4].QuadPart);
        }else if(fp->track[T_TM] == 4){
            d = (double)(g_ct[7].QuadPart - g_ct[6].QuadPart);
        }else{
            d = (double)(g_ct[1].QuadPart - g_ct[0].QuadPart);
        }
        sprintf(buf, "QPC:%e", d);
        SetWindowText(fp->hwnd, buf);
    }
#endif
    
    return TRUE;
}

//------------------------------------------------------------------------
// SIMDΉ`FbN
//------------------------------------------------------------------------
int is_simd_available(void)
{
    int ret = 0;
    unsigned long r_ecx,r_edx;
    
    // CPUIDɂ`FbN
    __asm {
        mov eax, 1
        cpuid
        mov r_edx, edx
        mov r_ecx, ecx
    }
    
    // MMX  0x0800000 edx
    // SSE  0x2000000 edx
    // SSE2 0x4000000 edx
    // SSE3 0x0000001 ecx
    r_edx &= 0x6800000U;
    r_ecx &= 0x1U;
    
    if(r_edx & 0x0800000U)
        ret |= SIMD_MMX;
    
    if(r_edx & 0x2000000U)
        ret |= SIMD_SSE;
    
    if(r_edx & 0x4000000U)
        ret |= SIMD_SSE2;
    
    if(ret <= SIMD_MMX)
        return ret;
    
    // OST|[gĂ邩
    __try {
        __asm xorps xmm0, xmm0
    }
    
    __except(EXCEPTION_EXECUTE_HANDLER){
        if(_exception_code()==STATUS_ILLEGAL_INSTRUCTION)
            return (ret & SIMD_MMX);
    }
    
    return ret;
}

//------------------------------------------------------------------------
// |C^ƃXgCh16ByteEɍǂ`FbN
//------------------------------------------------------------------------
int is_aligned_16b(const void *p0, const void *p1, int s)
{
    ULONG_PTR pp0 = (ULONG_PTR)p0;
    ULONG_PTR pp1 = (ULONG_PTR)p1;
    ULONG_PTR tmp = s * sizeof(PIXEL_YC);

    tmp = (tmp | pp0 | pp1) & 0xFU;

    return tmp ? 0 : 1;
}

//------------------------------------------------------------------------
// Ɨ̈m
//------------------------------------------------------------------------
BOOL alloc_work(mov_cache *mc, int h, int w)
{
    size_t sz,ws;
    
    // TCYύX͈xJ
    if(mc->h < h || mc->w < w){
        func_exit(NULL);
    }
    
    // mۂ݂Ȃ̂ŉȂ
    if(mc->buf){
        return TRUE;
    }

    // ŜAP[g
    ws = ((unsigned int)w + 7U) & ~7U; //8̔{
    ws += 8; //E̗]T
    sz = (ws * (h + 3) * 3) * sizeof(short); //㉺̗]T
    mc->buf = VirtualAlloc(NULL, sz, MEM_COMMIT, PAGE_READWRITE);
    if(NULL == mc->buf){
        return FALSE;
    }

    // eobt@ʒuvZ
    mc->mv[0].mask = (short*)mc->buf;
    mc->temp = mc->mv[0].mask + ws * (h + 2);
    mc->mv[1].mask = mc->temp + ws * (h + 2);

    //㉺ɗ]T
    mc->mv[0].mask += ws;
    mc->temp       += ws + 128; //܂
    mc->mv[1].mask += ws + 256; //܂
    
    mc->mv[0].frame = mc->mv[1].frame = -1;
    
    mc->h = h;
    mc->w = w;
    
    return TRUE;
}

//------------------------------------------------------------------------
// ֐̃Zbg
//------------------------------------------------------------------------
void set_mt_proc(int mask)
{
    int simd;
    
    //SIMD̃`FbN
    simd = is_simd_available();
    simd &= mask;
    
    if(simd & SIMD_SSE2){
        f_setth = set_rth_sse;
        mp_lpf[0] = mt_proc_lpf_sse2u;
        mp_lpf[1] = mt_proc_lpf_sse2;
        mp_abs[0] = mt_proc_abs_sse2u;
        mp_abs[1] = mt_proc_abs_sse2;
        mp_mov = mt_proc_mov_sse2;
        mp_blend = mt_proc_blend_sse2;
    }else if(simd & SIMD_SSE){
        f_setth = set_rth_sse;
        mp_lpf[0] = mp_lpf[1] = mt_proc_lpf_mmx;
        mp_abs[0] = mp_abs[1] = mt_proc_abs_sse;
        mp_mov = mt_proc_mov_sse;
        mp_blend = mt_proc_blend_sse;
    }else if(simd & SIMD_MMX){
        f_setth = set_rth;
        mp_lpf[0] = mp_lpf[1] = mt_proc_lpf_mmx;
        mp_abs[0] = mp_abs[1] = mt_proc_abs;
        mp_mov = mt_proc_mov;
        mp_blend = mt_proc_blend;
    }else{
        f_setth = set_rth;
        mp_lpf[0] = mp_lpf[1] = mt_proc_lpf;
        mp_abs[0] = mp_abs[1] = mt_proc_abs;
        mp_mov = mt_proc_mov;
        mp_blend = mt_proc_blend;
    }
}

//------------------------------------------------------------------------
// }`Xbh֐
//------------------------------------------------------------------------
BOOL mt_exec_dummy(MULTI_THREAD_FUNC fn, void *p1, void *p2)
{
    fn(0, 1, p1, p2);
    return TRUE;
}

