//----------------------------------------------------------------------------------
//  mov.c : o
//  Copyright (c) 2005-2008  N099
//----------------------------------------------------------------------------------
#include <windows.h>

#include "filter.h"
#include "mov.h"

// gpW
static const __m128 xc_f4k = { 4096.0f, 4096.0f, 4096.0f, 4096.0f };

//臒l`ɃZbg
void set_rth(float rth[4], int th)
{
    float tmp;
    
    if(th){
        tmp = 4096.0f/(th * th);
    }else{
        tmp = 4096.0f;
    }

    rth[3] = rth[2] = rth[1] = rth[0] = tmp;
}

//臒l`ɃZbg(SSE)
void set_rth_sse(float rth[4], int th)
{
    __m128 tmp;
    
    if(th == 0){
        th = 1;
    }

    tmp = _mm_cvtsi32_ss(xc_f4k, th);
    tmp = _mm_mul_ss(tmp, tmp);
    tmp = _mm_div_ss(xc_f4k, tmp);
    tmp = _mm_shuffle_ps(tmp, tmp, 0);

    _mm_store_ps(rth, tmp);
}

//o
NOA void detect_motion(short * restrict dst, short * restrict src,
                       int w, int s, int th, const float rth[4])
{
    int i,j;
    short ss;
    short df[5];
    int sa;
    float f;
    const float r = rth[0];
    
    //c
    //㉺Eɗ]TƂ
    *(src - 1) = *src;
    *(src + w) = *(src + w - 1);
    
    for(i=0; i<w; ++i){
        df[0] = *(src + i);
        df[1] = *(src + i + 1);
        df[2] = *(src + i - 1);
        df[3] = *(src + i + s);
        df[4] = *(src + i - s);
        
        //\[gčől𓾂
        for(j=0; j<4; ++j){
            if(df[j]>df[j+1]){
                ss = df[j];
                df[j] = df[j+1];
                df[j+1] = ss;
            }
        }
        
        //2Ԗڂɑ傫Ȓl𓾂
        for(j=0; j<3; ++j){
            if(df[j]>df[j+1]){
                df[j+1] = df[j];
            }
        }
        
        //ς
        sa = (df[3] + df[4] + 1)/2;
        
        //臒lŏd݂
        f  = sa * sa * r + 0.5f;
        sa = (f > 4096.0f) ? 4096 : (int)f;
        
        *(dst + i) = (short)sa;
     }
}

//o SSE
NOA void detect_motion_sse(short * restrict dst, short * restrict src,
                           int w, int s, int th, const float rth[4])
{
    int i;
    __m64 s0,s1,s2,s3,s4,t0;
    __m128 f0;
    const __m128 r0 = _mm_load_ps(rth);
    
    //̈c{
    // ㉺Eɗ]TƂ
    *(src - 1) = *src;
    *(src + w) = *(src + w - 1);
    
    for(i=0; i<w; i+=4){
        //load
        s0 = *(__m64 * restrict)(src + i + 1); //ACgĂȂ
        s1 = *(__m64 * restrict)(src + i - 1); //ACgĂȂ
        s2 = *(__m64 * restrict)(src + i + s);
        s3 = *(__m64 * restrict)(src + i - s);
        s4 = *(__m64 * restrict)(src + i);
        
        //\[gčől𓾂
        t0 = _mm_max_pi16(s4, s3);
        s4 = _mm_min_pi16(s4, s3);
        s3 = t0;
        t0 = _mm_max_pi16(s3, s2);
        s3 = _mm_min_pi16(s3, s2);
        s2 = t0;
        t0 = _mm_max_pi16(s2, s1);
        s2 = _mm_min_pi16(s2, s1);
        s1 = t0;
        t0 = _mm_max_pi16(s1, s0);
        s1 = _mm_min_pi16(s1, s0);
        s0 = t0;
        
        //2Ԗڂɑ傫Ȓl𓾂
        s3 = _mm_max_pi16(s3, s4);
        s2 = _mm_max_pi16(s2, s3);
        s1 = _mm_max_pi16(s1, s2);
        
        //ς
        t0 = _mm_avg_pu16(s0, s1);
        
        //臒lŏd݂
        f0 = _mm_cvtpu16_ps(t0);
        f0 = _mm_mul_ps(f0, f0);
        f0 = _mm_mul_ps(f0, r0);
        f0 = _mm_min_ps(f0, xc_f4k);
        
        *(__m64 * restrict)(dst + i) = _mm_cvtps_pi16(f0);
    }
}

//o SSE2
NOA void detect_motion_sse2(short * restrict dst, short * restrict src,
                            int w, int s, int th, const float rth[4])
{
    int i;
    __m128i xs0,xs1,xs2,xs3,xs4,xt0;
    __m128 xf0,xf1;
    const __m128 xr0 = _mm_load_ps(rth);
    
    //̈c{
    // ㉺Eɗ]TƂ
    *(src - 1) = *src;
    *(src + w) = *(src + w - 1);
    
    for(i=0; i<w; i+=8){
        //load
        xs0 = _mm_loadu_si128((__m128i * restrict)(src + i + 1)); //ACgĂȂ
        xs1 = _mm_loadu_si128((__m128i * restrict)(src + i - 1)); //ACgĂȂ
        xs2 = _mm_load_si128((__m128i * restrict)(src + i + s));
        xs3 = _mm_load_si128((__m128i * restrict)(src + i - s));
        xs4 = _mm_load_si128((__m128i * restrict)(src + i));
        
        //\[gčől𓾂
        xt0 = _mm_max_epi16(xs4, xs3);
        xs4 = _mm_min_epi16(xs4, xs3);
        xs3 = xt0;
        xt0 = _mm_max_epi16(xs3, xs2);
        xs3 = _mm_min_epi16(xs3, xs2);
        xs2 = xt0;
        xt0 = _mm_max_epi16(xs2, xs1);
        xs2 = _mm_min_epi16(xs2, xs1);
        xs1 = xt0;
        xt0 = _mm_max_epi16(xs1, xs0);
        xs1 = _mm_min_epi16(xs1, xs0);
        xs0 = xt0;
        
        //2Ԗڂɑ傫Ȓl𓾂
        xs3 = _mm_max_epi16(xs3, xs4);
        xs2 = _mm_max_epi16(xs2, xs3);
        xs1 = _mm_max_epi16(xs1, xs2);
        
        //ς
        xs0 = _mm_avg_epu16(xs0, xs1);
        
        //臒lŏd݂
        xt0 = _mm_unpacklo_epi16(xs0, _mm_setzero_si128());
        xs0 = _mm_unpackhi_epi16(xs0, _mm_setzero_si128());
        xf0 = _mm_cvtepi32_ps(xt0);
        xf1 = _mm_cvtepi32_ps(xs0);
        
        //臒l傫ꍇ4096ɂ
        xf0 = _mm_mul_ps(xf0, xf0);
        xf1 = _mm_mul_ps(xf1, xf1);
        xf0 = _mm_mul_ps(xf0, xr0);
        xf1 = _mm_mul_ps(xf1, xr0);
        xf0 = _mm_min_ps(xf0, xc_f4k);
        xf1 = _mm_min_ps(xf1, xc_f4k);
        xt0 = _mm_cvtps_epi32(xf0);
        xs0 = _mm_cvtps_epi32(xf1);
        xt0 = _mm_packs_epi32(xt0, xs0);
        
        _mm_store_si128((__m128i * restrict)(dst + i), xt0);
    }
}

//oitF[hmj
NOA void detect_motion2(short * restrict dst, short * restrict src,
                        int w, int s, int th, const float rth[4])
{
    int i,j;
    short ss,s0;
    short df[5];
    int sa,sb;
    float f;
    const float r = rth[0];
    
    //c
    //㉺Eɗ]TƂ
    *(src - 1) = *src;
    *(src + w) = *(src + w - 1);
    
    for(i=0; i<w; ++i){
        df[0] = s0 = *(src + i);
        df[1] = *(src + i + s);
        df[2] = *(src + i - s);
        df[3] = *(src + i + 1);
        df[4] = *(src + i - 1);
        
        //c3pixel\[g
        for(j=0; j<2; ++j){
            if(df[j]>df[j+1]){
                ss = df[j];
                df[j] = df[j+1];
                df[j+1] = ss;
            }
        }
        if(df[0]>df[1]){
            ss = df[0];
            df[0] = df[1];
            df[1] = ss;
        }
        
        //fBAƂƂ̒lr
        sb = abs(df[1] - s0) > th ? 4096 : 0;
        
        //\[gčől𓾂i3ԂƕĂ̂͏j
        for(j=1; j<4; ++j){
            if(df[j]>df[j+1]){
                ss = df[j];
                df[j] = df[j+1];
                df[j+1] = ss;
            }
        }
        
        //2Ԗڂɑ傫Ȓl𓾂
        for(j=1; j<3; ++j){
            if(df[j]>df[j+1]){
                df[j+1] = df[j];
            }
        }
        
        //ς
        sa = (df[3] + df[4] + 1)/2;
        
        //臒lŏd݂
        f  = sa * sa * r + 0.5f;
        sa = (f > 4096.0f) ? 4096 : (int)f;
        
        *(dst + i) = (short)(sb>sa ? sb : sa);
     }
}

//o SSEitF[hmj
NOA void detect_motion2_sse(short * restrict dst, short * restrict src,
                            int w, int s, int th, const float rth[4])
{
    int i;
    __m64 s0,s1,s2,s3,s4,t0,t1;
    __m128 f0;
    const __m128 r0 = _mm_load_ps(rth);
    const __m64 th2 = _mm_shuffle_pi16(_mm_cvtsi32_si64(th), 0);
    static const u64_i16 mc_4k = { 4096, 4096, 4096, 4096 };
    
    //̈c{
    // ㉺Eɗ]TƂ
    *(src - 1) = *src;
    *(src + w) = *(src + w - 1);
    
    for(i=0; i<w; i+=4){
        //load
        s0 = *(__m64 * restrict)(src + i + 1); //ACgĂȂ
        s1 = *(__m64 * restrict)(src + i - 1); //ACgĂȂ
        s2 = *(__m64 * restrict)(src + i + s);
        s3 = *(__m64 * restrict)(src + i - s);
        s4 = *(__m64 * restrict)(src + i);
        t1 = s4;
        
        //c3pixel\[g
        t0 = _mm_max_pi16(s4, s3);
        s4 = _mm_min_pi16(s4, s3);
        s3 = t0;
        t0 = _mm_max_pi16(s3, s2);
        s3 = _mm_min_pi16(s3, s2);
        s2 = t0;
        t0 = _mm_max_pi16(s4, s3);
        s4 = _mm_min_pi16(s4, s3);
        s3 = t0;
        
        //fBAƂƂ̒lr
        t1 = _mm_subs_pi16(t1, s3);
        t0 = _mm_subs_pi16(_mm_setzero_si64(), t1);
        t1 = _mm_max_pi16(t1, t0);
        t1 = _mm_cmpgt_pi16(t1, th2);
        t1 = _mm_and_si64(t1, mc_4k.m);
        
        //\[gčől𓾂i3ԂƕĂ̂͏j
        t0 = _mm_max_pi16(s3, s2);
        s3 = _mm_min_pi16(s3, s2);
        s2 = t0;
        t0 = _mm_max_pi16(s2, s1);
        s2 = _mm_min_pi16(s2, s1);
        s1 = t0;
        t0 = _mm_max_pi16(s1, s0);
        s1 = _mm_min_pi16(s1, s0);
        s0 = t0;
        
        //2Ԗڂɑ傫Ȓl𓾂
        s2 = _mm_max_pi16(s2, s3);
        s1 = _mm_max_pi16(s1, s2);
        
        //ς
        t0 = _mm_avg_pu16(s0, s1);
        
        //臒lŏd݂
        f0 = _mm_cvtpu16_ps(t0);
        f0 = _mm_mul_ps(f0, f0);
        f0 = _mm_mul_ps(f0, r0);
        f0 = _mm_min_ps(f0, xc_f4k);
        t0 = _mm_cvtps_pi16(f0);
        
        *(__m64 * restrict)(dst + i) = _mm_max_pi16(t0, t1);
    }
}

//o SSE2itF[hmj
NOA void detect_motion2_sse2(short * restrict dst, short * restrict src,
                             int w, int s, int th, const float rth[4])
{
    int i;
    __m128i xs0,xs1,xs2,xs3,xs4,xt0,xt1;
    __m128 xf0,xf1;
    const __m128 xr0 = _mm_load_ps(rth);
    const __m128i xth2 = _mm_set1_epi16((short)th);
    static const u128i_i16 xc_4k = { 4096, 4096, 4096, 4096, 4096, 4096, 4096, 4096 };
    
    //̈c{
    // ㉺Eɗ]TƂ
    *(src - 1) = *src;
    *(src + w) = *(src + w - 1);
    
    for(i=0; i<w; i+=8){
        //load
        xs0 = _mm_loadu_si128((__m128i * restrict)(src + i + 1)); //ACgĂȂ
        xs1 = _mm_loadu_si128((__m128i * restrict)(src + i - 1)); //ACgĂȂ
        xs2 = _mm_load_si128((__m128i * restrict)(src + i + s));
        xs3 = _mm_load_si128((__m128i * restrict)(src + i - s));
        xs4 = _mm_load_si128((__m128i * restrict)(src + i));
        xt1 = xs4;
        
        //c3pixel\[g
        xt0 = _mm_max_epi16(xs4, xs3);
        xs4 = _mm_min_epi16(xs4, xs3);
        xs3 = xt0;
        xt0 = _mm_max_epi16(xs3, xs2);
        xs3 = _mm_min_epi16(xs3, xs2);
        xs2 = xt0;
        xt0 = _mm_max_epi16(xs4, xs3);
        xs4 = _mm_min_epi16(xs4, xs3);
        xs3 = xt0;
        
        //fBAƂƂ̒lr
        xt1 = _mm_subs_epi16(xt1, xs3);
        xt0 = _mm_subs_epi16(_mm_setzero_si128(), xt1);
        xt1 = _mm_max_epi16(xt1, xt0);
        xt1 = _mm_cmpgt_epi16(xt1, xth2);
        xt1 = _mm_and_si128(xt1, xc_4k.x);
        
        //\[gčől𓾂i3ԂƕĂ̂͏j
        xt0 = _mm_max_epi16(xs3, xs2);
        xs3 = _mm_min_epi16(xs3, xs2);
        xs2 = xt0;
        xt0 = _mm_max_epi16(xs2, xs1);
        xs2 = _mm_min_epi16(xs2, xs1);
        xs1 = xt0;
        xt0 = _mm_max_epi16(xs1, xs0);
        xs1 = _mm_min_epi16(xs1, xs0);
        xs0 = xt0;
        
        //2Ԗڂɑ傫Ȓl𓾂
        xs2 = _mm_max_epi16(xs2, xs3);
        xs1 = _mm_max_epi16(xs1, xs2);
        
        //ς
        xs0 = _mm_avg_epu16(xs0, xs1);
        
        //臒lŏd݂
        xt0 = _mm_unpacklo_epi16(xs0, _mm_setzero_si128());
        xs0 = _mm_unpackhi_epi16(xs0, _mm_setzero_si128());
        xf0 = _mm_cvtepi32_ps(xt0);
        xf1 = _mm_cvtepi32_ps(xs0);
        
        //臒l傫ꍇ4096ɂ
        xf0 = _mm_mul_ps(xf0, xf0);
        xf1 = _mm_mul_ps(xf1, xf1);
        xf0 = _mm_mul_ps(xf0, xr0);
        xf1 = _mm_mul_ps(xf1, xr0);
        xf0 = _mm_min_ps(xf0, xc_f4k);
        xf1 = _mm_min_ps(xf1, xc_f4k);
        xt0 = _mm_cvtps_epi32(xf0);
        xs0 = _mm_cvtps_epi32(xf1);
        xt0 = _mm_packs_epi32(xt0, xs0);
        xt0 = _mm_max_epi16(xt0, xt1);
        
        _mm_store_si128((__m128i * restrict)(dst + i), xt0);
    }
}

